/*
 * Copyright (c) 2000 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Knit component composition software.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation is hereby granted without fee, provided that the above
 * copyright notice and this permission/disclaimer notice is retained in all
 * copies or modified versions, and that both notices appear in supporting
 * documentation.  THE COPYRIGHT HOLDERS PROVIDE THIS SOFTWARE "AS IS" AND
 * WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.  THE COPYRIGHT HOLDERS DISCLAIM ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */

typedef union sexpr *sexpr;

#define nil 0
sexpr cons( sexpr car, sexpr cdr );
sexpr car( sexpr x ); 
sexpr cdr( sexpr x ); 
int is_cons( sexpr x ); 
int is_string( sexpr x );
sexpr string( char* s );
sexpr fast_string( char* s ); // doesn't make a copy
char* stringOf( sexpr x ); 
sexpr thing( char* s, sexpr args );
char* thingOf( sexpr x ); 
sexpr argsOf( sexpr x );
sexpr other( char* s );
char* otherOf( sexpr x ); 
void release( sexpr x ); 
void pp( sexpr x ); 
void up( sexpr x ); 

#define singleton(x)     cons((x),nil)
#define doubleton(x,y)   cons((x),singleton(y))
#define tripleton(x,y,z) cons((x),doubleton(y,z))
#define quadleton(a,b,c,d) cons((a),tripleton(b,c,d))

#define pair(x,y)     cons(x,y)
#define triple(x,y,z) cons(x,pair(y,z))
#define quad(a,b,c,d) pair(pair(a,b),pair(c,d))

sexpr reverse(sexpr x);
