## -*- mode: Makefile -*-
##
## Copyright (c) 2000 University of Utah and the Flux Group.
## All rights reserved.
## 
## This file is part of the Knit component composition software.
## 
## Permission to use, copy, modify, distribute, and sell this software and
## its documentation is hereby granted without fee, provided that the above
## copyright notice and this permission/disclaimer notice is retained in all
## copies or modified versions, and that both notices appear in supporting
## documentation.  THE COPYRIGHT HOLDERS PROVIDE THIS SOFTWARE "AS IS" AND
## WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION,
## THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
## PURPOSE.  THE COPYRIGHT HOLDERS DISCLAIM ANY LIABILITY OF ANY KIND FOR
## ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
## 
## Users are requested, but not required, to send to csl-dist@cs.utah.edu any
## improvements that they make and grant Univ. of Utah redistribution rights.
##

###############################################################################

# Extra files that go into this document.
#
EXTRAFILES	= $(UNITFILES)

UNITFILES	= \
		Hello-unit.unit Hello-comments.unit \
		\
		Msg-bundletypes.unit Msg-Main.unit Msg-Messages.unit \
		Msg-Msg.unit \
		\
		Calc-Input.unit Calc-Alloc.unit Calc-Alloc_T-Expr.unit \
		Calc-Token.unit Calc-Alloc_2.unit

###############################################################################

vpath %.unit	$(TOP_SRCDIR)/examples/hello
vpath %.unit	$(TOP_SRCDIR)/examples/msg
vpath %.unit	$(TOP_SRCDIR)/examples/calc

GETDEFS = $(TOP_SRCDIR)/unsupported/getdefs

Hello-unit.unit: hello.unit
	$(GETDEFS) MATCHING=Hello HEADERS=0 $< > $@

Hello-comments.unit: hello.unit
	$(GETDEFS) MATCHING=Hello HEADERS=1 $< > $@

Msg-bundletypes.unit: msg.unit
	$(GETDEFS) MATCHING='_T$$' HEADERS=1 $< > $@

Msg-Main.unit: msg.unit
	$(GETDEFS) MATCHING='Main$$' HEADERS=1 $< > $@

Msg-Messages.unit: msg.unit
	$(GETDEFS) MATCHING=Messages HEADERS=0 $< > $@

Msg-Msg.unit: msg.unit
	$(GETDEFS) MATCHING='Msg$$' HEADERS=0 $< > $@

Calc-Input.unit: calc.unit
	$(GETDEFS) MATCHING='Input$$' HEADERS=0 $< > $@

Calc-Alloc_T-Expr.unit: calc.unit
	$(GETDEFS) MATCHING='(Alloc_T|Expr)$$' HEADERS=0 $< > $@

Calc-Alloc.unit: calc.unit
	$(GETDEFS) MATCHING='Alloc$$' HEADERS=0 $< > $@

Calc-Token.unit: calc.unit
	$(GETDEFS) MATCHING='Token$$' HEADERS=0 $< > $@

Calc-Alloc_2.unit: calc.unit
	$(GETDEFS) MATCHING='Alloc_2$$' HEADERS=0 $< > $@

###############################################################################

## End of file.

