/*
 * Copyright (c) 2000 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * Permission to use, copy, modify, and distribute this file
 * for any purpose with or without restriction is hereby granted.
 */

#ifndef _EXPR_H_
#define _EXPR_H_

#include "number.h"
#include "token.h"

/*****************************************************************************/

typedef struct expr_struct *expr;

typedef enum {
	EXPR_KIND_ERROR,
	EXPR_KIND_ERROR_TOKEN,
	
	EXPR_KIND_NUMBER,
	
	EXPR_KIND_UPOS,
	EXPR_KIND_UNEG,
	
	EXPR_KIND_BADD,
	EXPR_KIND_BSUB,
	EXPR_KIND_BMUL,
	EXPR_KIND_BDIV
} expr_kind;

/*****************************************************************************/

int init_exprs(void);

expr alloc_error_no_mem_expr(void);
expr alloc_error_token_expr(token tok);
expr alloc_number_expr(number num);
expr alloc_unary_expr(expr_kind kind, expr child);
expr alloc_binary_expr(expr_kind kind, const expr left, const expr right);
void free_expr(expr e);

int expr_is_erroneous(expr e);

expr expr_eval(expr e);

void expr_print(expr e);

/*****************************************************************************/

#endif /* _EXPR_H_ */

/* End of file. */

