/*
 * Copyright (c) 2000 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * Permission to use, copy, modify, and distribute this file
 * for any purpose with or without restriction is hereby granted.
 */

#include "main.h"
#include "repl.h"

/*****************************************************************************/

int
main(int argc, char **argv)
{
	/*
	 * If we weren't using Knit, we would have to call our initializer
	 * functions here.  We would have to know which to call and in what
	 * order they must be called.  This can be tricky, because we might not
	 * know which components are actually *in* the current program!
	 *
	 * But because we Knit our code, Knit schedules calls to initializers
	 * for us, based on the components in our program and the dependencies
	 * that exist between those components.  Further, the Knit runtime
	 * support in `init.c' ensures that the initializers are run before
	 * `main' is even invoked.  So, with initialization taken care of, we
	 * can just get on with the show!
	 */
	repl();
	/*
	 * If we weren't using Knit, we would have to call our finalizers here.
	 */
	return 0;
}

/*****************************************************************************/

/* End of file. */

