/*
 * Copyright (c) 2000 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * Permission to use, copy, modify, and distribute this file
 * for any purpose with or without restriction is hereby granted.
 */

#ifndef _NUMBER_H_
#define _NUMBER_H_

/*****************************************************************************/

typedef long number;

int string_to_number(const char *str, number *out_num, const char** out_end);
int int_to_number(int i, number *out_num);
int copy_number(number n, number *out_num);
void free_number(number n);

int number_is_zero(number n);
int number_neg(number n, number *out);
int number_add(number a, number b, number *out);
int number_sub(number a, number b, number *out);
int number_mul(number a, number b, number *out);
int number_div(number a, number b, number *out);
     
void number_print(number n);

/*****************************************************************************/

#endif /* _NUMBER_H_ */

/* End of file. */

