/*
 * Copyright (c) 2000 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * Permission to use, copy, modify, and distribute this file
 * for any purpose with or without restriction is hereby granted.
 */

#ifndef _TOKEN_H_
#define _TOKEN_H_

#include "number.h"

/*****************************************************************************/

typedef struct token_struct *token;

typedef enum {
	TOKEN_KIND_ERROR,
	TOKEN_KIND_EOF,
	
	TOKEN_KIND_NUMBER,
	
	TOKEN_KIND_PLUS,
	TOKEN_KIND_MINUS,
	TOKEN_KIND_STAR,
	TOKEN_KIND_SLASH,
	TOKEN_KIND_OPEN_PAREN,
	TOKEN_KIND_CLOSE_PAREN
} token_kind;

/*****************************************************************************/

int init_tokens(void);

void start_tokenizer(const char *str);
void end_tokenizer(void);

token copy_token(token t);
void free_token(token t);

int token_is_erroneous(token t);
token_kind token_get_kind(token t);
number token_get_number(token t);

token next_token(void);
void push_token(token t);

void token_print(token t);

/*****************************************************************************/

#endif /* _TOKEN_H_ */

/* End of file. */

